package com.javacorporate.forum.dbobj;

/*
 * ForumMail.java
 *
 * Copyright 1999 Javacorporate Ltd.
 */

import com.javacorporate.dbobj.*;
import com.javacorporate.common.dbobj.NextNumber;
import com.javacorporate.db.*;
import java.util.Calendar;
import com.javacorporate.common.util.DateTime;

/**
 * ForumMail 
 *
 * @version		$Revision: 1.2 $  $Date: 2000/04/07 18:35:19 $
 * @author		Michael Nash
 */
public class ForumMail extends SecuredDBObject {

	/**
	 * @see com.javacorporate.dbobj.SecuredDBObject
	 */
	public ForumMail() throws DBException {
		super();
	} /* ForumMail() */
	/**
	 * @see com.javacorporate.dbobj.SecuredDBObject
	 */
	public ForumMail(String theUser) throws DBException {

		super(theUser);
	} /* ForumMail(String) */
	/**
	 * Extends the usual add method to fetch a next number field
	 * and set the created date/time
	 *
	 * @throws	DBException If the next number cannot be determined or
	 * 			the add fails
	 */
	public void add() throws DBException {
		NextNumber myNext = new NextNumber("SYSTEM");
		long myIdNum = myNext.getNextTentative("FMAIL");
		setField("MailId", new String().valueOf(myIdNum));

		super.add();
		myNext.getNextConfirm("FMAIL");
	} /* add() */
	/**
	 * @see com.javacorporate.dbobj.SecuredDBObject#getThisDBObj()	 
	 *
	 * @returns	DBObject
	 * @throws	DBException
	 */
	public DBObject getThisDBObj() throws DBException {
		return new ForumMail();
	} /* getThisDBObj() */
	/**
	 * @see com.javacorporate.dbobj.SecuredDBObject
	 */
	protected synchronized void setupFields() throws DBException {
		setTargetTable("FORUMMAIL");

		setDescription("Forum Mail");

		addField("MailId", "int", 0, false, "Mail Id");
		addField("MessageId", "varchar", 255, false, "Message Id");
		addField("InReponseTo", "int", 0, false, "In Response To");
		addField("UserName", "char", 30, false, "User Name");
		addField("EMail", "varchar", 80, true, "EMail");

		addKey("MailId");
		setReadOnly("MailId");
	} /* setupFields() */
} /* ForumMail */
